diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/__init__.py
index c45f243c0..93263a101 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/__init__.py
@@ -13,6 +13,8 @@ import simplejson as json
 from functools import wraps
 
 import pgadmin.browser.server_groups.servers.databases as database
+import pgadmin.browser.server_groups.servers.databases.schemas.tables.\
+    constraints.index_constraint.utils as idxcons_utils
 from flask import render_template, make_response, request, jsonify
 from flask_babelex import gettext as _
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.\
@@ -247,16 +249,10 @@ class IndexConstraintView(PGChildNodeView):
                 .format(self.manager.version)
 
             # We need parent's name eg table name and schema name
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=kwargs['tid'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
+            schema, table = idxcons_utils.get_parent(self.conn, kwargs['tid'])
+            self.schema = schema
+            self.table = table
 
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
             return f(*args, **kwargs)
 
         return wrap
@@ -284,49 +280,20 @@ class IndexConstraintView(PGChildNodeView):
         Returns:
 
         """
-        sql = render_template("/".join([self.template_path, 'properties.sql']),
-                              did=did,
-                              tid=tid,
-                              cid=cid,
-                              constraint_type=self.constraint_type)
-        status, res = self.conn.execute_dict(sql)
-
+        status, res = idxcons_utils.get_index_constraints(self.conn, did, tid,
+                                                          self.constraint_type,
+                                                          cid)
         if not status:
-            return internal_server_error(errormsg=res)
+            return res
 
-        if len(res['rows']) == 0:
+        if len(res) == 0:
             return gone(_("""Could not find the {} in the table.""".format(
                 "primary key" if self.constraint_type == "p" else "unique key"
             )))
 
-        result = res['rows'][0]
-
-        sql = render_template(
-            "/".join([self.template_path, 'get_constraint_cols.sql']),
-            cid=cid,
-            colcnt=result['col_count'])
-        status, res = self.conn.execute_dict(sql)
-
-        if not status:
-            return internal_server_error(errormsg=res)
-
-        columns = []
-        for row in res['rows']:
-            columns.append({"column": row['column'].strip('"')})
-
-        result['columns'] = columns
-
-        # Add Include details of the index supported for PG-11+
-        if self.manager.version >= 110000:
-            sql = render_template(
-                "/".join([self.template_path, 'get_constraint_include.sql']),
-                cid=cid)
-            status, res = self.conn.execute_dict(sql)
-
-            if not status:
-                return internal_server_error(errormsg=res)
-
-            result['include'] = [col['colname'] for col in res['rows']]
+        result = res
+        if cid:
+            result = res[0]
 
         return ajax_response(
             response=result,
@@ -381,16 +348,9 @@ class IndexConstraintView(PGChildNodeView):
             .format(self.manager.version)
 
         # We need parent's name eg table name and schema name
-        SQL = render_template("/".join([self.template_path,
-                                        'get_parent.sql']),
-                              tid=tid)
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
-
-        for row in rset['rows']:
-            self.schema = row['schema']
-            self.table = row['table']
+        schema, table = idxcons_utils.get_parent(self.conn, tid)
+        self.schema = schema
+        self.table = table
 
         SQL = render_template("/".join([self.template_path, 'properties.sql']),
                               did=did,
@@ -503,16 +463,9 @@ class IndexConstraintView(PGChildNodeView):
             .format(self.manager.version)
 
         # We need parent's name eg table name and schema name
-        SQL = render_template("/".join([self.template_path,
-                                        'get_parent.sql']),
-                              tid=tid)
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
-
-        for row in rset['rows']:
-            self.schema = row['schema']
-            self.table = row['table']
+        schema, table = idxcons_utils.get_parent(self.conn, tid)
+        self.schema = schema
+        self.table = table
 
         res = []
         SQL = render_template("/".join([self.template_path, 'nodes.sql']),
@@ -686,7 +639,8 @@ class IndexConstraintView(PGChildNodeView):
         try:
             data['schema'] = self.schema
             data['table'] = self.table
-            sql, name = self.get_sql(data, did, tid, cid)
+            sql, name = idxcons_utils.get_sql(self.conn, data, did, tid,
+                                              self.constraint_type, cid)
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -826,7 +780,8 @@ class IndexConstraintView(PGChildNodeView):
         data['schema'] = self.schema
         data['table'] = self.table
         try:
-            sql, name = self.get_sql(data, did, tid, cid)
+            sql, name = idxcons_utils.get_sql(self.conn, data, did, tid,
+                                              self.constraint_type, cid)
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -840,77 +795,6 @@ class IndexConstraintView(PGChildNodeView):
         except Exception as e:
             return internal_server_error(errormsg=str(e))
 
-    def get_sql(self, data, did, tid, cid=None):
-        """
-        This function will generate sql from model data.
-
-        Args:
-          data: Contains the data of the selected primary key constraint.
-          tid: Table ID.
-          cid: Primary key constraint ID
-
-        Returns:
-
-        """
-        if cid is not None:
-            sql = render_template(
-                "/".join([self.template_path, 'properties.sql']),
-                did=did,
-                tid=tid,
-                cid=cid,
-                constraint_type=self.constraint_type
-            )
-            status, res = self.conn.execute_dict(sql)
-            if not status:
-                return internal_server_error(errormsg=res)
-            if len(res['rows']) == 0:
-                return gone(
-                    _("""Could not find the {} in the table.""".format(
-                        "primary key" if self.constraint_type == "p"
-                        else "unique key"
-                    ))
-                )
-
-            old_data = res['rows'][0]
-            required_args = [u'name']
-            for arg in required_args:
-                if arg not in data:
-                    data[arg] = old_data[arg]
-
-            sql = render_template("/".join([self.template_path, 'update.sql']),
-                                  data=data,
-                                  o_data=old_data)
-        else:
-            required_args = [
-                [u'columns', u'index']  # Either of one should be there.
-            ]
-
-            def is_key_str(key, data):
-                return isinstance(data[key], str) and data[key] != ""
-
-            def is_key_list(key, data):
-                return isinstance(data[key], list) and len(data[param]) > 0
-
-            for arg in required_args:
-                if isinstance(arg, list):
-                    for param in arg:
-                        if param in data:
-                            if is_key_str(param, data) \
-                                    or is_key_list(param, data):
-                                break
-                    else:
-                        return _('-- definition incomplete')
-
-                elif arg not in data:
-                    return _('-- definition incomplete')
-
-            sql = render_template("/".join([self.template_path, 'create.sql']),
-                                  data=data,
-                                  conn=self.conn,
-                                  constraint_name=self.constraint_name)
-
-        return sql, data['name'] if 'name' in data else old_data['name']
-
     @check_precondition
     def sql(self, gid, sid, did, scid, tid, cid=None):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/utils.py
new file mode 100644
index 000000000..64db8352d
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/utils.py
@@ -0,0 +1,232 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2019, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+""" Implements Utility class for Exclusion Constraint. """
+
+from flask import render_template
+from flask_babelex import gettext as _
+from pgadmin.utils.ajax import internal_server_error
+from pgadmin.utils.exception import ObjectGone
+from functools import wraps
+
+
+def get_template_path(f):
+    """
+    This function will behave as a decorator which will prepare
+    the template path based on database server version.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold the connection object
+        conn_obj = args[0]
+        template_path = ''
+        if 'template_path' not in kwargs:
+            template_path = 'index_constraint/sql/#{0}#'.format(
+                conn_obj.manager.version)
+        else:
+            template_path = kwargs['template_path']
+
+        return f(*args, **kwargs, template_path=template_path)
+    return wrap
+
+
+@get_template_path
+def get_parent(conn, tid, template_path=None):
+    """
+    This function will return the parent of the given table.
+    :param conn: Connection Object
+    :param tid: Table oid
+    :param template_path:
+    :return:
+    """
+
+    SQL = render_template("/".join([template_path,
+                                    'get_parent.sql']), tid=tid)
+    status, rset = conn.execute_2darray(SQL)
+    if not status:
+        raise Exception(rset)
+
+    schema = ''
+    table = ''
+    if 'rows' in rset and len(rset['rows']) > 0:
+        schema = rset['rows'][0]['schema']
+        table = rset['rows'][0]['table']
+
+    return schema, table
+
+
+@get_template_path
+def get_index_constraints(conn, did, tid, ctype, cid=None, template_path=None):
+    """
+    This function is used to fetch information of the
+    index constraint(s) for the given table.
+    :param conn: Connection Object
+    :param did: Database ID
+    :param tid: Table ID
+    :param ctype: Constraint Type
+    :param cid: index Constraint ID
+    :param template_path: Template Path
+    :return:
+    """
+
+    sql = render_template("/".join([template_path, 'properties.sql']),
+                          did=did, tid=tid, cid=cid, constraint_type=ctype)
+    status, result = conn.execute_dict(sql)
+    if not status:
+        return status, internal_server_error(errormsg=result)
+
+    for idx_cons in result['rows']:
+        sql = render_template("/".join([template_path,
+                                        'get_constraint_cols.sql']),
+                              cid=idx_cons['oid'],
+                              colcnt=idx_cons['col_count'])
+        status, res = conn.execute_dict(sql)
+        if not status:
+            return status, internal_server_error(errormsg=res)
+
+        columns = []
+        for r in res['rows']:
+            columns.append({"column": r['column'].strip('"')})
+
+        idx_cons['columns'] = columns
+
+        # INCLUDE clause in index is supported from PG-11+
+        if conn.manager.version >= 110000:
+            sql = render_template("/".join([template_path,
+                                            'get_constraint_include.sql']),
+                                  cid=idx_cons['oid'])
+            status, res = conn.execute_dict(sql)
+            if not status:
+                return status, internal_server_error(errormsg=res)
+
+            idx_cons['include'] = [col['colname'] for col in res['rows']]
+
+    return True, result['rows']
+
+
+@get_template_path
+def get_index_constraint_sql(conn, did, tid, data, template_path=None):
+    """
+    This function will return sql for index constraints.
+    :param conn: Connection Object
+    :param did: Database ID
+    :param tid: Table ID
+    :param data: Data
+    :param template_path: Template Path
+    :return:
+    """
+    sql = []
+    # We will fetch all the index constraints for the table
+    index_constraints = {
+        'p': 'primary_key', 'u': 'unique_constraint'
+    }
+
+    for ctype in index_constraints.keys():
+        # Check if constraint is in data
+        # If yes then we need to check for add/change/delete
+        if index_constraints[ctype] in data:
+            constraint = data[index_constraints[ctype]]
+            # If constraint(s) is/are deleted
+            if 'deleted' in constraint:
+                for c in constraint['deleted']:
+                    c['schema'] = data['schema']
+                    c['table'] = data['name']
+
+                    # Sql for drop
+                    sql.append(render_template("/".join([template_path,
+                                                         'delete.sql']),
+                                               data=c,
+                                               conn=conn).strip('\n'))
+            if 'changed' in constraint:
+                for c in constraint['changed']:
+                    c['schema'] = data['schema']
+                    c['table'] = data['name']
+
+                    modified_sql, name = get_sql(conn, c, did, tid, ctype,
+                                                 c['oid'])
+                    sql.append(modified_sql.strip('\n'))
+
+            if 'added' in constraint:
+                for c in constraint['added']:
+                    c['schema'] = data['schema']
+                    c['table'] = data['name']
+
+                    add_sql, name = get_sql(conn, c, did, tid, ctype)
+                    sql.append(add_sql.strip("\n"))
+
+    if len(sql) > 0:
+        # Join all the sql(s) as single string
+        return '\n\n'.join(sql)
+    else:
+        return None
+
+
+@get_template_path
+def get_sql(conn, data, did, tid, ctype, cid=None, template_path=None):
+    """
+    This function will generate sql from model data.
+    :param conn: Connection Object
+    :param data: data
+    :param did: Database ID
+    :param tid: Table id
+    :param ctype: Constraint Type
+    :param cid: index Constraint ID
+    :param template_path: Template Path
+    :return:
+    """
+    name = data['name'] if 'name' in data else None
+    if cid is not None:
+        sql = render_template("/".join([template_path, 'properties.sql']),
+                              did=did, tid=tid, cid=cid,
+                              constraint_type=ctype)
+        status, res = conn.execute_dict(sql)
+        if not status:
+            raise Exception(res)
+
+        if len(res['rows']) == 0:
+            raise ObjectGone(
+                _('Could not find the constraint in the table.'))
+
+        old_data = res['rows'][0]
+        if 'name' not in data:
+            name = data['name'] = old_data['name']
+
+        sql = render_template("/".join([template_path, 'update.sql']),
+                              data=data,
+                              o_data=old_data)
+    else:
+        required_args = [
+            [u'columns', u'index']  # Either of one should be there.
+        ]
+
+        def is_key_str(key, data):
+            return isinstance(data[key], str) and data[key] != ""
+
+        def is_key_list(key, data):
+            return isinstance(data[key], list) and len(data[param]) > 0
+
+        for arg in required_args:
+            if isinstance(arg, list):
+                for param in arg:
+                    if param in data:
+                        if is_key_str(param, data) or is_key_list(param, data):
+                            break
+                else:
+                    return _('-- definition incomplete'), name
+
+            elif arg not in data:
+                return _('-- definition incomplete'), name
+
+        sql = render_template("/".join([template_path, 'create.sql']),
+                              data=data,
+                              conn=conn,
+                              constraint_name='PRIMARY KEY'
+                              if ctype == 'p' else 'UNIQUE')
+    return sql, name
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py
index 5ea7e9479..1a475c913 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py
@@ -13,6 +13,8 @@ import simplejson as json
 from functools import wraps
 
 import pgadmin.browser.server_groups.servers.databases as database
+import pgadmin.browser.server_groups.servers.databases.schemas.tables.\
+    indexes.utils as index_utils
 from flask import render_template, request, jsonify
 from flask_babelex import gettext
 from pgadmin.browser.collection import CollectionNodeModule
@@ -256,17 +258,9 @@ class IndexesView(PGChildNodeView):
             # We need parent's name eg table name and schema name
             # when we create new index in update we can fetch it using
             # property sql
-            SQL = render_template(
-                "/".join([self.template_path, 'get_parent.sql']),
-                tid=kwargs['tid']
-            )
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
+            schema, table = index_utils.get_parent(self.conn, kwargs['tid'])
+            self.schema = schema
+            self.table = table
 
             return f(*args, **kwargs)
 
@@ -474,99 +468,6 @@ class IndexesView(PGChildNodeView):
             status=200
         )
 
-    def _column_details(self, idx, data, mode='properties'):
-        """
-        This functional will fetch list of column details for index
-
-        Args:
-            idx: Index OID
-            data: Properties data
-
-        Returns:
-            Updated properties data with column details
-        """
-
-        SQL = render_template(
-            "/".join([self.template_path, 'column_details.sql']), idx=idx
-        )
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
-        # 'attdef' comes with quotes from query so we need to strip them
-        # 'options' we need true/false to render switch ASC(false)/DESC(true)
-        columns = []
-        cols = []
-        for row in rset['rows']:
-            # We need all data as collection for ColumnsModel
-            # we will not strip down colname when using in SQL to display
-            cols_data = {
-                'colname': row['attdef'] if mode == 'create' else
-                row['attdef'].strip('"'),
-                'collspcname': row['collnspname'],
-                'op_class': row['opcname'],
-            }
-
-            # ASC/DESC and NULLS works only with btree indexes
-            if 'amname' in data and data['amname'] == 'btree':
-                cols_data['sort_order'] = False
-                if row['options'][0] == 'DESC':
-                    cols_data['sort_order'] = True
-
-                cols_data['nulls'] = False
-                if row['options'][1].split(" ")[1] == 'FIRST':
-                    cols_data['nulls'] = True
-
-            columns.append(cols_data)
-
-            # We need same data as string to display in properties window
-            # If multiple column then separate it by colon
-            cols_str = row['attdef']
-            if row['collnspname']:
-                cols_str += ' COLLATE ' + row['collnspname']
-            if row['opcname']:
-                cols_str += ' ' + row['opcname']
-
-            # ASC/DESC and NULLS works only with btree indexes
-            if 'amname' in data and data['amname'] == 'btree':
-                # Append sort order
-                cols_str += ' ' + row['options'][0]
-                # Append nulls value
-                cols_str += ' ' + row['options'][1]
-
-            cols.append(cols_str)
-
-        # Push as collection
-        data['columns'] = columns
-        # Push as string
-        data['columns_csv'] = ', '.join(cols)
-
-        return data
-
-    def _include_details(self, idx, data, mode='properties'):
-        """
-        This functional will fetch list of include details for index
-        supported with Postgres 11+
-
-        Args:
-            idx: Index OID
-            data: Properties data
-
-        Returns:
-            Updated properties data with include details
-        """
-
-        SQL = render_template(
-            "/".join([self.template_path, 'include_details.sql']), idx=idx
-        )
-        status, rset = self.conn.execute_2darray(SQL)
-
-        if not status:
-            return internal_server_error(errormsg=rset)
-
-        # Push as collection
-        data['include'] = [col['colname'] for col in rset['rows']]
-        return data
-
     @check_precondition
     def properties(self, gid, sid, did, scid, tid, idx):
         """
@@ -602,11 +503,11 @@ class IndexesView(PGChildNodeView):
         data = dict(res['rows'][0])
 
         # Add column details for current index
-        data = self._column_details(idx, data)
+        data = index_utils.get_column_details(self.conn, idx, data)
 
         # Add Include details of the index
         if self.manager.version >= 110000:
-            data = self._include_details(idx, data)
+            data = index_utils.get_include_details(self.conn, idx, data)
 
         return ajax_response(
             response=data,
@@ -806,7 +707,8 @@ class IndexesView(PGChildNodeView):
         data['schema'] = self.schema
         data['table'] = self.table
         try:
-            SQL, name = self.get_sql(did, scid, tid, idx, data)
+            SQL, name = index_utils.get_sql(
+                self.conn, data, did, tid, idx, self.datlastsysoid)
             if not isinstance(SQL, (str, unicode)):
                 return SQL
             SQL = SQL.strip('\n').strip(' ')
@@ -855,7 +757,9 @@ class IndexesView(PGChildNodeView):
         data['table'] = self.table
 
         try:
-            sql, name = self.get_sql(did, scid, tid, idx, data, mode='create')
+            sql, name = index_utils.get_sql(
+                self.conn, data, did, tid, idx, self.datlastsysoid,
+                mode='create')
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -868,64 +772,6 @@ class IndexesView(PGChildNodeView):
         except Exception as e:
             return internal_server_error(errormsg=str(e))
 
-    def get_sql(self, did, scid, tid, idx, data, mode=None):
-        """
-        This function will genrate sql from model data
-        """
-        if idx is not None:
-            SQL = render_template(
-                "/".join([self.template_path, 'properties.sql']),
-                did=did, tid=tid, idx=idx, datlastsysoid=self.datlastsysoid
-            )
-
-            status, res = self.conn.execute_dict(SQL)
-            if not status:
-                return internal_server_error(errormsg=res)
-            if len(res['rows']) == 0:
-                return gone(
-                    gettext("""Could not find the index in the table.""")
-                )
-
-            old_data = dict(res['rows'][0])
-
-            # If name is not present in data then
-            # we will fetch it from old data, we also need schema & table name
-            if 'name' not in data:
-                data['name'] = old_data['name']
-
-            SQL = render_template(
-                "/".join([self.template_path, 'update.sql']),
-                data=data, o_data=old_data, conn=self.conn
-            )
-        else:
-            required_args = {
-                'name': 'Name',
-                'columns': 'Columns'
-            }
-            for arg in required_args:
-                err = False
-                if arg == 'columns' and len(data['columns']) < 1:
-                    err = True
-
-                if arg not in data:
-                    err = True
-                    # Check if we have at least one column
-                if err:
-                    return gettext('-- definition incomplete')
-
-            # If the request for new object which do not have did
-            SQL = render_template(
-                "/".join([self.template_path, 'create.sql']),
-                data=data, conn=self.conn, mode=mode
-            )
-            SQL += "\n"
-            SQL += render_template(
-                "/".join([self.template_path, 'alter.sql']),
-                data=data, conn=self.conn
-            )
-
-        return SQL, data['name'] if 'name' in data else old_data['name']
-
     @check_precondition
     def sql(self, gid, sid, did, scid, tid, idx):
         """
@@ -940,40 +786,9 @@ class IndexesView(PGChildNodeView):
            idx: Index ID
         """
 
-        SQL = render_template(
-            "/".join([self.template_path, 'properties.sql']),
-            did=did, tid=tid, idx=idx, datlastsysoid=self.datlastsysoid
-        )
-
-        status, res = self.conn.execute_dict(SQL)
-        if not status:
-            return internal_server_error(errormsg=res)
-        if len(res['rows']) == 0:
-            return gone(gettext("""Could not find the index in the table."""))
-
-        data = dict(res['rows'][0])
-        # Adding parent into data dict, will be using it while creating sql
-        data['schema'] = self.schema
-        data['table'] = self.table
-
-        # Add column details for current index
-        data = self._column_details(idx, data, 'create')
-
-        # Add Include details of the index
-        if self.manager.version >= 110000:
-            data = self._include_details(idx, data, 'create')
-
-        SQL, name = self.get_sql(did, scid, tid, None, data)
-        if not isinstance(SQL, (str, unicode)):
-            return SQL
-        sql_header = u"-- Index: {0}\n\n-- ".format(data['name'])
-
-        sql_header += render_template(
-            "/".join([self.template_path, 'delete.sql']),
-            data=data, conn=self.conn
-        )
-
-        SQL = sql_header + '\n\n' + SQL
+        SQL = index_utils.get_reverse_engineered_sql(
+            self.conn, self.schema, self.table, did, tid, idx,
+            self.datlastsysoid)
 
         return ajax_response(response=SQL)
 
